#!/bin/bash
## node-usage.sh
## Author:
## Quail <quail.linux@gmail.com> http://quail.southernvaleslug.org
## Created on 8th April 2010. Updated - 9th April 2010
## Licensed under the GPL version 3.
##
## Get usage information from Internode's API.
## requires: curl and gawk
##
## Refer to README for instructions and info.

## DO NOT EDIT THIS FILE UNLESS YOU KNOW WHAT YOUR DOING.

ver=0.0.2

conf_dir=$HOME/.config/internode
cache_dir=$conf_dir/cache
log=$conf_dir/node-usage.log

if [ ! -d $cache_dir ]; then 
mkdir -p $cache_dir
fi

# Grab the details
if [ ! -f $HOME/.netrc ]; then
echo "Have you read the README...."
exit 0
else
curl -s -n -A "Node Usage for Conky $ver" https://customer-webtools-api.internode.on.net/api/v1.5/ > /tmp/api
fi

sleep 1

service=$(cat /tmp/api |sed -n 2p|cut -d">" -f5|cut -d"<" -f1)

if [ ! $service ]; then
echo "`date +%b` `date +%e` `date +%T` : connect error unknown" >> $log
exit 0
else
curl -s -n -A "Node Usage for Conky $ver" https://customer-webtools-api.internode.on.net/api/v1.5/$service/usage > $cache_dir/usage
fi

# Process the usage
rollover=$(cat $cache_dir/usage |sed -n 2p|cut -d"=" -f5|cut -d'"' -f2)
quota=$(cat $cache_dir/usage |sed -n 2p|cut -d"=" -f7|cut -d'"' -f2)
used=$(cat $cache_dir/usage |sed -n 2p|cut -d">" -f6|cut -d"<" -f1)

# Break up the values into their respective parts
echo "$used $quota" > $cache_dir/node-text.txt
echo "Used: $(cat $cache_dir/node-text.txt | gawk '{print $1/1000/1000}') MB" > $cache_dir/node-used.txt 
echo "Quota: $(cat $cache_dir/node-text.txt | gawk '{print $2/1000/1000}') MB" > $cache_dir/node-quota.txt

# Generate the percent used.
cat $cache_dir/node-text.txt | gawk '{print $1/$2*100}' > $cache_dir/node-graph.txt
percent=$(cat $cache_dir/node-graph.txt)
echo $(printf %.0f $percent) > $cache_dir/node-percent.txt

# Generate the days left
today=$(date +%s)
rollunixdate=$(date +%s -d"$rollover 23:59:59")
diffunix=$(expr $rollunixdate - $today)
echo "Days Left: $(expr $diffunix / 86400)" > $cache_dir/node-roll.txt

exit
